<template>
  <div class="row q-mb-sm">

    <div class="col-1" v-if="!isMain">
      <q-icon class="q-pt-md" @click.prevent.stop="onDeleteLine" @mousedown.prevent.stop=""
              dense flat name="la la-times" color="orange" size="xs"
      />
    </div>

    <template v-if="form.type === 'operator'">
      <div class="col-4">
        <q-select
          dense
          class="q-pr-md" hide-dropdown-icon
          label="Opérateur" options-dense
          v-model="form.operand"
          :options="operators"
          option-label="label"
          option-value="value"
        />
      </div>
      <div class="col-2">
        <q-btn size="sm" stretch dense color="primary" flat icon="la la-plus" class="q-pt-md">
          <q-menu>
            <q-list separator dense>
              <q-item dense clickable @click.prevent="onAddLine('condition')">
                <q-item-section>Ajouter une condition</q-item-section>
              </q-item>
              <q-item dense clickable v-ripple @click.prevent="onAddLine('operator')">
                <q-item-section avatar>Ajouter un groupe</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </q-btn>
      </div>
    </template>

    <template v-if="form.type === 'condition'">
      <div class="col-4">
        <q-select
          options-dense hide-dropdown-icon
          class="q-pr-md"
          label="Champ" dense
          v-model="form.field"
          :options="fields"
          option-label="label"
          option-value="field"
        />
      </div>
      <div class="col-3" v-if="showOperandField">
        <q-select
          options-dense hide-dropdown-icon
          class="q-pr-md"
          label="Condition" dense
          v-model="form.operand"
          :options="conditions"
          option-label="label"
          option-value="value"
        />
      </div>
      <div class="col-4">

        <q-checkbox v-if="form.field && form.field.type === 'boolean'"
          label="" v-model="form.value" class="q-mt-xs"
        />
        <q-input v-else label="Recherche"
                 v-model="form.value"
                 :type="form.field && form.field.type ? form.field.type : 'text' "
                 dense/>
      </div>
    </template>

    <div class="col-12" v-if="form.children">
      <div class="row">
        <div class="col-1"></div>
        <div class="col-11">
          <filter-line
            v-for="(subFilter, key) in form.children"
            v-model="form.children[key]"
            :fields="fields"
            :key="key"
            @on-delete-line="onDelete(subFilter, key)"
          />
        </div>
      </div>
    </div>

  </div>
</template>

<script>
  export default {
    name: 'FilterLine',
    components: {},
    model: {
      prop: 'value',
      event: 'input',
    },
    props: {
      isMain: {
        type: [Boolean],
        default: false
      },
      fields: {
        type: Array,
      },
      value: {
        type: Object,
      }
    },
    data() {
      return {
        operands: [
          {label: 'Et', value: 'and', type: 'operator',},
          {label: 'Ou', value: 'or', type: 'operator',},
          {label: 'Egale à', value: 'equal', type: 'condition',},
          {label: 'Diff. de', value: 'not-equal', type: 'condition',},
          {label: 'Contient', value: 'contains', type: 'condition',},
          {label: 'Commence par', value: 'start', type: 'condition',},
          {label: 'Fini par', value: 'end', type: 'condition',},
        ],
        showOperandField: true,
        form: {
          type: '',
          operand: null,
          field: null,
          value: '',
          children: [],
        }
      }
    },

    methods: {
      onAddLine(type) {
        this.form.children.splice(this.form.children.length, 0, {
          type,
          value: '',
          field: null,
          operand: type === 'operator' ? {label: 'Et', value: 'and', type: 'operator',} : {label: 'Contient', value: 'contains', type: 'condition',},
          children: [],
        })
      },

      onDeleteLine($event) {
        this.$emit('on-delete-line')
      },

      onDelete(event, index) {
        this.form.children.splice(index, 1)
      },
    },

    computed: {
      conditions() {
        return this.operands.filter(x => x.type === 'condition')
      },

      operators() {
        return this.operands.filter(x => x.type === 'operator')
      },
    },

    watch: {
      'form.field': {
        handler: function (newValue, oldValue) {
          if (newValue){
            if (newValue.type === 'boolean'){
              this.showOperandField = false
              this.form.operand = {label: 'Egale à', value: 'equal', type: 'condition'}
            }else{
              this.form.operand = {label: 'Contient', value: 'contains', type: 'condition'}
              this.showOperandField = true
            }
          }
        },
        deep: true,
        immediate: true,
      },

      value: {
        handler: function (newValue, oldValue) {
          this.form = newValue
        },
        deep: true,
        immediate: true,
      },
      form: {
        handler: function (newValue, oldValue) {
          this.$emit('input', newValue)
        },
        deep: true,
        immediate: true,
      },
    },
  }
</script>

